leetcode题解-3、Longest Substring Without Repeating Characters

题意:给定一个字符串,求最长不重复子串(非子序列)。

例子:
Input: “abcabcbb”
Output: 3
分析: “abc”, 它的长度为 3.

Input: “bbbbb”
Output: 1
分析: “b”, 它的长度为 1.

Input: “pwwkew”
Output: 3
分析: The answer is “wke”, with the length of 3.
注意:子串(substring)和子序列(subsequence )的区别, “pwke” 是一个子序列而不是子串。

分析:最长不重复子串有三种解法。
1、暴力解
2、双指针
3、双指针优化解

1、暴力解
逐个检查所有子字符串,看它是否没有重复的字符。
时间复杂度 O ( n 3 ) O(n^{3}) O(n3)
空间复杂度 O ( m i n ( m , n ) ) O(min(m,n)) O(min(m,n)) m m m是字符的种类数, n n n是字符串的长度。

public class Solution {
    public int lengthOfLongestSubstring(String s) {
        int n = s.length();
        int ans = 0;
        for (int i = 0; i < n; i++)
            for (int j = i + 1; j <= n; j++)
                if (allUnique(s, i, j)) ans = Math.max(ans, j - i);
        return ans;
    }

    public boolean allUnique(String s, int start, int end) {
        Set set = new HashSet<>();
        for (int i = start; i < end; i++) {
            Character ch = s.charAt(i);
            if (set.contains(ch)) return false;
            set.add(ch);
        }
        return true;
    }
}

2、双指针法
暴力求解时间复杂度显然不能接受。那么用HashSet将字符存储在当前窗口[i,j)中(初始化j = i)。 然后将索引j向右滑动。 如果它不在HashSet中,我们进一步向右滑动j。 这样做直到s [j]已经在HashSet中。 此时,我们就找到了以s[i]开头的无重复字符的子字符串的最大长度。 如果对所有s[i]重复上述步骤,就可以得到全局最大长度。
时间复杂度$O(2n) = O(n) $
空间复杂度 O ( m i n ( m , n ) ) O(min(m,n)) O(min(m,n)) m m m是字符的种类数, n n n是字符串的长度。

public static int lengthOfLongestSubstring(String s) {
        int len = s.length();
        int maxLen = 0;
        HashSet set = new HashSet();
        int i = 0; 
        int j = 0;
        int count = 0;
        while(i < len && j < len){
        	if(set.contains(s.charAt(j))){
        		set.remove(s.charAt(i++));
        		count--;
        	}else{
        		set.add(s.charAt(j++));
        		count++;
        	}
        	maxLen = Math.max(count, maxLen);
        }
        
        
        return maxLen;
    }

c++

#include 
#include 
#include 
#include 
using namespace std;

class Solution {
public:
    int lengthOfLongestSubstring(string s) {
        int len = s.length();
        set c_set;
        int i = 0, j = 0;
        int count = 0;
        int max_len = 0;
        char tmp = s[2];
        while (i < len && j < len) {
            if (c_set.find(s[j]) != c_set.end()) {
                c_set.erase(s[i]);
                i++;
                count--;
            }else{
                c_set.insert(s[j]);
                j++;
                count++;
            }
            max_len = max(max_len, count);
        }
        return max_len;
    }
};

int main() {
    Solution sl;
    int max_len = sl.lengthOfLongestSubstring("pwwke");
    std::cout << max_len << std::endl;
    return 0;
}

3、双指针方法的优化
方案2最多需要2n步。 实际上,它可以优化为仅需要n步。我们可以使用map来定义字符到其索引的映射,而不是使用set来判断字符是否存在。 然后,当我们找到重复的字符时,我们可以立即跳过重复的字符。

如果s[j]在[i,j)的范围内有一个重复的字符s[j’],我们不需要对索引i一步一步的增加,我们可以直接跳过[i,j’],令i=j’+1即可。
时间复杂度$O(n) $
空间复杂度 O ( m i n ( m , n ) ) O(min(m,n)) O(min(m,n)) m m m是字符的种类数, n n n是字符串的长度。

public class Solution {
    public int lengthOfLongestSubstring(String s) {
        int n = s.length(), ans = 0;
        Map map = new HashMap<>(); // current index of character
        // try to extend the range [i, j]
        for (int j = 0, i = 0; j < n; j++) {
            if (map.containsKey(s.charAt(j))) {
                i = Math.max(map.get(s.charAt(j)), i);
            }
            ans = Math.max(ans, j - i + 1);
            map.put(s.charAt(j), j + 1);
        }
        return ans;
    }
}

你可能感兴趣的:(Leetcode题解)